- name: Install/Update Wallet
  tags:
    - install
    - wallet
  block:
    - name: Create {{ client_oracle_home }}/network/admin/ directory if it does not exist
      ansible.builtin.file:
        path: "{{ client_oracle_home }}/network/admin"
        state: directory
        mode: '0755'
        owner: oracle
        group: oinstall

    - name: Generate SQLNET.ORA file
      ansible.builtin.template:
        src: sqlnet.ora.j2
        dest: "{{ client_oracle_home }}/network/admin/sqlnet.ora"
        owner: oracle
        group: oinstall
        backup: true
        mode: '0644'

    - name: Create Wallet directory if it does not exist
      ansible.builtin.file:
        path: "{{ client_wallet_folder }}/{{ database_fe_sid }}"
        state: directory
        mode: '0755'
        owner: "{{ svfe_user }}"
        group: oinstall

    - name: Create Wallet
      become_user: "{{ svfe_user }}"
      become_flags: -i
      no_log: true
      ansible.builtin.shell: "{{ client_oracle_home }}/bin/orapki wallet create -wallet {{ client_wallet_folder }}/{{ database_fe_sid }} -auto_login_local -pwd {{ client_wallet_password }}"
      args:
        creates: "{{ client_wallet_folder }}/{{ database_fe_sid }}/cwallet.sso"

    - name: Pause for creating private key
      ansible.builtin.pause:
        seconds: 10


    - name: List  Wallet
      vars:
        ansible_python_interpreter: /usr/bin/python3
      become_user: "{{ svfe_user }}"
      become_flags: -i
      no_log: true
      ansible.builtin.expect:
        command: "{{ client_oracle_home }}/bin/mkstore -wrl {{ client_wallet_folder }}/{{ database_fe_sid }} -listCredential"
        responses:
          Enter wallet password: "{{ client_wallet_password }}"
      register: client_wallet_list_out
      changed_when: false

    - name: Parse output
      no_log: true
      ansible.builtin.shell: "echo \"{{ client_wallet_list_out.stdout }}\" | grep \"{{ database_fe_sid }} {{ database_fe_login }}\""
      register: parse_out
      changed_when: false
      ignore_errors: true
      when:
        - client_wallet_list_out.rc == 0

    - name: Add credentials to Wallet
      vars:
        ansible_python_interpreter: /usr/bin/python3
      become_user: "{{ svfe_user }}"
      become_flags: -i
      no_log: true
      ansible.builtin.expect:
        command: "{{ client_oracle_home }}/bin/mkstore -wrl {{ client_wallet_folder }}/{{ database_fe_sid }} -createCredential {{ database_fe_sid }} {{ database_fe_login }} {{ database_fe_password }}"
        responses:
          Enter wallet password: "{{ client_wallet_password }}"
      when:
        - (parse_out.rc | float) > 0
